library EXE2;

uses
  SysUtils,
  Windows,
  Classes,
  Controls;

{$R *.RES}

Const  Inputs   = 3;         // number of inputs
       Outputs  = 0;         // number of outputs made adjustable

       {INPUTS}
       PROG     = 0;            // index
       PARAM    = 1;
       START    = 2;

       {OUTPUTS}

       {USER}
       MyStart = 0;

       DLLIndex = 100;       // fixed index of DLL No. (set by ProfiLab)

Type TDLLParams = array[0..100] of extended;   //Type of ProfiLab DLL parameters
     PDLLParams = ^TDLLParams;                 // Pointer to ProfiLab DLL parameters

type TStringParams = array[0..100] of PChar;
     PStringParams = ^TStringParams;


function NumInputs: Byte;
begin
  result:=Inputs; //Define FIXED number of component input pins
end;

function NumOutputs: Byte; // Made adjustable with 'NumOutputsEx'
begin
  result:=Outputs; //Define FIXED number of component output pins
end;

{function NumInputsEx(PUser: PDLLParams): Byte; //Just in case number of inputs need to be variable
begin
  result:=...; //Define VARIABLE number of component input pins
end;}
{
function NumOutputsEx(PUser: PDLLParams): Byte;
begin
  result:= 8; //8 bit
end;
}
Function InputName(Channel: Byte): ShortString; // Return name for each component input pin
begin
  case Channel of
  PROG  : result:='$PROG';
  PARAM : result:='$PARAM';
  START : result:= '/E';
  end;
end;

Function OutputName(Channel: Byte): ShortString; // Return name for each component output pin
begin
//
end;

Procedure SimStart(PInput,POutput,PUser: PDLLParams); //called when ProfiLab enters RUN mode
begin
  PUser^[MyStart]:= 5;
end;

Procedure SimStop(PInput,POutput,PUser: PDLLParams); //called when ProfiLab RUN mode is terminated
begin
  // nothing to be done
end;

Procedure CalculateEx(PInput,POutput,PUser: PDLLParams; PStrings: PStringParams); //called regularly from ProfiLab
var s,pfad,parameter : string;
begin
  if (PUser^[MyStart] > 2.5) and (PInput^[START] < 2.5) then
  begin
    s:= PStrings[PROG];
    pfad:= ExtractFilePath(s);

    if pfad = '' then
    begin
      getdir(0,pfad);
      if length(pfad) < 3 then pfad:= pfad + '\';
      s:= pfad + '\' + s;
    end;

    parameter:= PStrings[PARAM];
    s:= s + ' ' + parameter;

    WinExec(PChar(s),SW_SHOW);
    PUser^[MyStart]:= 0;
  end;

  if (PUser^[MyStart] < 2.5) and (PInput^[START] > 2.5) then
  begin
    PUser^[MyStart]:= 5;
  end;
end;

Procedure Configure(PUser: PDLLParams);
begin
//
end;


//export methods for ProfiLab
exports SimStart,
        SimStop,
        NumInputs,
        NumOutputs,
        CalculateEx,
        InputName,
        OutputName,
        Configure;
begin
end.

