{$A+,B-,C-,D-,E-,F-,G+,H+,I-,J+,K-,L-,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y-,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}
library HotKey;

uses
  SysUtils,
  Windows,
  Classes,
  Controls,
  Dlg_HotkeyConfig in 'Dlg_HotkeyConfig.pas' {HotkeyConfigDlg};

{$R *.RES}

Const  Inputs = 1;  // number of inputs

       {INPUTS}
       CLK   = 0;   // index of input variable CLK

       {OUTPUTS}

       {USER}
       CLK_old = 0;          // index of user variable CLK_old
       CTRL  = 1;            // index of user variable CTRL
       SHIFT = 2;            // index of user variable SHIFT
       ALT   = 3;            // index of user variable ALT
       KEY   = 4;            // index of user variable ALT
       DLLIndex = 100;       // fixed index of DLL No. (set by ProfiLab)

Type TDLLParams = array[0..100] of extended;   //Type of ProfiLab DLL parameters
     PDLLParams = ^TDLLParams;                 // Pointer to ProfiLab DLL parameters


function NumInputs: Byte;
begin
  result:=Inputs; //Define FIXED number of component input pins
end;

{function NumOutputs: Byte; // Made adjustable with 'NumOutputsEx'
begin
  result:=Outputs; //Define FIXED number of component output pins
end;}

{function NumInputsEx(PUser: PDLLParams): Byte; //Just in case number of inputs need to be variable
begin
  result:=...; //Define VARIABLE number of component input pins
end;}

function NumOutputsEx(PUser: PDLLParams): Byte;
begin
   // Define VARIABLE number of component output pins
   result:=0; // Just to be complete
end;

Function InputName(Channel: Byte): ShortString; // Return name for each component input pin
begin
   case Channel of
   CLK: result:='CLK';   //  "CLK" (Clock)
   end;
end;

Function OutputName(Channel: Byte): ShortString; // Return name for each component output pin
begin
   result:='';
end;

Procedure SimStart(PInput,POutput,PUser: PDLLParams); //called when ProfiLab enters RUN mode
begin
  // nothing to be done
  PUser^[CLK_old]:= 0;
end;

Procedure SimStop(PInput,POutput,PUser: PDLLParams); //called when ProfiLab RUN mode is terminated
begin
  // nothing to be done
  PUser^[CLK_old]:= 0;
end;

Procedure Calculate(PInput,POutput,PUser: PDLLParams); //called regularly from ProfiLab
type
    TShiftKeyInfo = record
            shift : Byte;
            vkey  : Byte;
                  end;
    byteset = set of 0..7;

const shiftkeys : array [1..3] of TShiftKeyInfo = (
                  (shift: Ord(ssCtrl); vkey: VK_CONTROL),
                  (shift: Ord(ssShift); vkey: VK_SHIFT),
                  (shift: Ord(ssAlt); vkey: VK_MENU));

var SendKey    : WORD;
    Shiftstate : TShiftState;
    flag       : DWORD;
    bShift     : ByteSet; //absolute shift;
    i          : Integer;
begin
  if PInput^[CLK] < 2.5 then PUser^[CLK_old]:= 0;

  if (PInput^[CLK] > 2.5) and (PUser^[CLK_old] < 2.5) then //check out rising edge at CLK input
  begin
    PUser^[CLK_old]:= 5; //bereits einmal ausgefuehrt

    ShiftState:= [];
    if PUser^[CTRL]  = 1 then ShiftState:= ShiftState + [ssCTRL];
    if PUser^[SHIFT] = 1 then ShiftState:= ShiftState + [ssSHIFT];
    if PUser^[ALT]   = 1 then ShiftState:= ShiftState + [ssALT];
    bShift:=  ByteSet(ShiftState);

    i:= round(PUser^[Key]);
    SendKey:= 0;
    if i >= 0 then
    begin
      if i < 10 then SendKey:= i + 48
                else SendKey:= i + 55;
      if i >= 36 then SendKey:= 32;
    end;

    if SendKey > 0 then
    begin
      //Key senden
      for i := 1 to 3 do
      begin
        if shiftkeys[i].shift in bShift then keybd_event(shiftkeys[i].vkey,
                                                         MapVirtualKey(shiftkeys[i].vkey, 0),
                                                         0,
                                                         0);
      end;

      flag:= 0;
      keybd_event(Sendkey, MapvirtualKey(Sendkey, 0), flag, 0);
      flag:= flag or KEYEVENTF_KEYUP;
      keybd_event(Sendkey, MapvirtualKey(Sendkey, 0), flag, 0);
      //Key nochmal senden
      flag:= 0;
      keybd_event(Sendkey, MapvirtualKey(Sendkey, 0), flag, 0);
      flag:= flag or KEYEVENTF_KEYUP;
      keybd_event(Sendkey, MapvirtualKey(Sendkey, 0), flag, 0);

      for i := 3 downto 1 do
      begin
        if shiftkeys[i].shift in bShift then keybd_event(shiftkeys[i].vkey,
                                                         MapVirtualKey(shiftkeys[i].vkey, 0),
                                                         KEYEVENTF_KEYUP,
                                                         0);
      end; //for
    end;   //Sendkey
  end;     //Clk and not(oldclk)
end;

Procedure Configure(PUser: PDLLParams);
var DLG: THotKeyConfigDlg;
begin
  // call config. dialogue
  DLG:=THotKeyConfigDlg.Create(nil);      //Create user dialogue
  With DLG do
  begin
    Caption:='Hot Key [DLL'+FloatToStr(PUser^[DLLIndex])+']'; // Show ProfiLab DLL-Index in dialogue caption

    if (PUser^[CTRL] = 1) then CTRLCB.Checked:= true
                          else CTRLCB.Checked:= false;
    if (PUser^[SHIFT] = 1) then SHIFTCB.Checked:= true
                           else SHIFTCB.Checked:= false;
    if (PUser^[ALT] = 1) then ALTCB.Checked:= true
                         else ALTCB.Checked:= false;

    KeyCB.ItemIndex:=round(PUser^[Key]);       // Set dialogue values

    if ShowModal = mrOK then                               // Execute dialogue
    begin
      if CTRLCB.Checked then PUser^[CTRL]:= 1
                        else PUser^[CTRL]:= 0;
      if SHIFTCB.Checked then PUser^[SHIFT]:= 1
                         else PUser^[SHIFT]:= 0;
      if ALTCB.Checked then PUser^[ALT]:= 1
                       else PUser^[ALT]:= 0;

      PUser^[Key]:=KeyCB.ItemIndex;           // Read back values from dialogue;
    end;

    free;
  end;
end;


//export methods for ProfiLab
exports SimStart,
        SimStop,
        NumInputs,
        NumOutputsEx,
        Calculate,
        InputName,
        OutputName,
        Configure;
begin
end.

