{$A+,B-,C+,D-,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}

//https://www.delphipraxis.net/196337-windows-sound-aufnehmen.html
unit u_mainform;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, mmSystem, ExtCtrls, HotkeyManager, ComCtrls;

const LOCALIZED_KEYNAMES = True;

type TTyp = (t_none,t_Datei,t_Pfad,t_Zeit,t_Key);

type
  TMainForm = class(TForm)
    BeendenBTN: TButton;
    StartBTN: TButton;
    StopBTN: TButton;
    DateiED: TEdit;
    StatusBar: TStatusBar;
    procedure BeendenBTNClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure StartBTNClick(Sender: TObject);
    procedure StopBTNClick(Sender: TObject);
    procedure TimerEvent(Sender: TObject);
    procedure HKMHotKeyPressed(HotKey: Cardinal; Index: Word);
  private
    { Private-Deklarationen }
    Zeit      : cardinal;
    bStart    : boolean;
    HKI1,Key  : word;
    Modifier  : THKModifiers; //hkShift, hkCtrl, hkAlt, hkExt
  public
    { Public-Deklarationen }
    Pfad      : string;
    SaveDatei : string;
    Zeitdauer : cardinal;
    bTimer    : boolean;
    Timer     : TTimer;
    HKM       : THotKeyManager;
    HotKey    : THotKey;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
var i,n     : integer;
    s,sx,sn : string;
    typ     : TTyp;
begin
  Pfad:= ExtractFilePath(ParamStr(0));
  if length(pfad) < 3 then pfad:= pfad + '\';
  SaveDatei:= 'test';
  DateiED.Text:= SaveDatei;
  Zeitdauer:= 0;
  typ:= t_none;
  Modifier:= [];
  Key:= $45;
  StatusBar.SimpleText:= '';
  bStart:= false;
  bTimer:= false;

  if ParamCount > 1 then
  begin
    sn:= '';
    for i:= 1 to ParamCount do
    begin
      s:= ParamStr(i);
      if s <> '' then
      begin
        s:= uppercase(s);
        n:= pos('/',s);

        if n > 0 then //Parameter gefunden
        begin
          s:= copy(s,n+1,length(s) -n);
          if s <> '' then
          begin
            n:= pos(' ',s);
            if n = 0 then n:= length(s) +1;

            if (copy(s,1,n-1) = 'DATEI') then
            begin
              typ:= t_Datei;
              sn:= '';
            end;
            if (copy(s,1,n-1) = 'PFAD') then
            begin
              typ:= t_Pfad;
              sn:= '';
            end;
            if (copy(s,1,n-1) = 'ZEIT') then
            begin
              typ:= t_Zeit;
              sn:= '';
            end;
            if (copy(s,1,n-1) = 'KEY') then
            begin
              typ:= t_Key;
              sn:= '';
            end;
          end;
        end
        else begin  //Parameter auswerten
               case typ of
               t_none:  begin
                        end;
               t_Datei: begin
                          if sn <> '' then s:= sn + s;
                          if pos('.',s) > 0 then
                          begin
                            typ:= t_none;
                            sn:= '';
                            n:= pos('\',s);
                            if n > 0 then
                            begin
                              sx:= ExtractFilePath(s);
                              if sx <> '' then Pfad:= sx;
                              sx:= ExtractFileName(s);
                              if sx <> '' then
                              begin
                                n:= pos('.',sx);
                                if n > 0 then sx:= copy(sx,1,n-1);
                                SaveDatei:= sx;
                                DateiED.Text:= SaveDatei;
                              end;
                            end
                            else begin
                                   n:= pos('.',s);
                                   if n > 0 then s:= copy(s,1,n-1);
                                   SaveDatei:= s;
                                   DateiED.Text:= SaveDatei + '.wav';
                                 end;
                          end
                          else sn:= s + ' ';
                        end;
               t_Pfad:  begin
                          if sn <> '' then s:= sn + s;
                          Pfad:= s;
                          sn:= s + ' ';
                        end;
               t_Zeit:  begin
                          typ:= t_none;
                          ZeitDauer:= strtointdef(s,0);
                        end;
               t_Key:   begin
                          typ:= t_none;
                          Modifier:= [];
                          n:= pos('_',s);
                          if n > 0 then
                          begin
                            sx:= uppercase(copy(s,1,n-1));
                            if sx <> '' then
                            begin
                              s:= uppercase(copy(s,n+1,length(s)-n));
                              if pos('SHIFT',sx) > 0 then Modifier:= Modifier + [hkShift];
                              if pos('CTRL',sx) > 0 then Modifier:= Modifier + [hkCtrl];
                              if pos('ALT',sx) > 0 then Modifier:= Modifier + [hkAlt];
                            end;
                          end;
                          if s <> '' then Key:= ord(s[1]);
                        end;
             end; //case
           end;
      end; //if s
    end; //for

    if length(pfad) < 3 then pfad:= pfad + '\';
  end; //Paramcnt

  HKM:= THotKeyManager.Create(self);
  HKM.OnHotKeyPressed:= HKMHotKeyPressed;

  HotKey:= THotKey.Create(self);
  InsertControl(HotKey);
  HotKey.Visible:= false;
  HotKey.HotKey:= Key;
  HotKey.Modifiers:= Modifier; //hkShift, hkCtrl, hkAlt, hkExt
  HKI1:= HKM.AddHotKey(HotKey.HotKey);

  Timer:= TTimer.Create(self);
  Timer.Interval:= 1000;
  Timer.OnTimer:= TimerEvent;
  Timer.Enabled:= true;

  mciSendString('OPEN NEW TYPE WAVEAUDIO ALIAS mySound',nil,0,Handle);
  mciSendString('SET mySound ' +
                   'TIME FORMAT MS ' +
                   'BITSPERSAMPLE 16 ' +
                   'CHANNELS 2 ' +
                   'SAMPLESPERSEC 44100 ' +
                   'BYTESPERSEC 176400 ' +
                   'ALIGNMENT 4',
                   nil,0,handle);

  if ZeitDauer > 0 then
  begin
    Zeit:= ZeitDauer;
    bTimer:= true;
  end;
  if (paramcount > 1) and (SaveDatei <> '') then
  begin
    StartBTNClick(self); //starten
    WindowState:= wsminimized; //Anwendung minimieren
  end;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  if Timer <> nil then
  begin
    Timer.Enabled:= false;
    Timer.free;
  end;
  mciSendString('CLOSE mySound',nil,0,Handle);
  HKM.RemoveHotKey(HotKey.HotKey);
  HKM.Free;
  RemoveControl(HotKey);
  HotKey.Free;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  mciSendString('CLOSE mySound',nil,0,Handle);
end;

procedure TMainForm.TimerEvent(Sender: TObject);
begin
  if bTimer then
  begin
    if Zeit > 0 then dec(Zeit)
      else begin
             bTimer:= false;
             StopBTNClick(Self);
           end;
  end;

  if bStart and showing then StatusBar.SimpleText:= 'Aufzeichnung luft ...';
end;

procedure TMainForm.StartBTNClick(Sender: TObject);
var s : string;
    n : integer;
begin
  s:= DateiED.Text;
  n:= pos('.',s);
  if n > 0 then s:= copy(s,1,n-1);

  if (s <> '') and (pos('\',s) = 0) then
  begin
    SaveDatei:= s;
    bStart:= true;
    mciSendString('RECORD mySound',nil,0,Handle);
  end;
end;

procedure TMainForm.StopBTNClick(Sender: TObject);
begin
  bStart:= false;
  mciSendString('STOP mySound',nil,0,Handle);
  mciSendString(PChar('SAVE mySound "' + Pfad + SaveDatei + '.wav"'),nil,0,Handle);
  StatusBar.SimpleText:= 'Aufzeichnung beendet.';
  if ZeitDauer > 0 then BeendenBTNClick(self);
end;

procedure TMainForm.BeendenBTNClick(Sender: TObject);
begin
  close;
end;

procedure TMainForm.HKMHotKeyPressed(HotKey: Cardinal; Index: Word);
begin
  SetForegroundWindow(Application.Handle);
  if Index = HKI1 then
  begin
    ZeitDauer:= 1; //Programm im Anschluss beenden
    StopBTNClick(self);
  end;
end;

end.



